searchData={"items":[{"type":"module","title":"Wind","doc":"A pleasant Elixir websocket client library based on Mint.","ref":"Wind.html"},{"type":"function","title":"Wind.connect/3","doc":"Statelessly connect to a websocket URL.  This is a convenience function\naround Mint that establishes a connection to `uri` and then subsequently\nupgrades the connection.","ref":"Wind.html#connect/3"},{"type":"function","title":"Examples - Wind.connect/3","doc":"iex> URL.new!(\"wss://example.com/ws\") |> Wind.connect()\n    {:ok, conn, ref}","ref":"Wind.html#connect/3-examples"},{"type":"function","title":"Wind.decode/4","doc":"Statelessly decode a websocket message.  This is a convenience function that\nwraps Mint.WebSocket `stream/2` and `decode/2` functions.","ref":"Wind.html#decode/4"},{"type":"function","title":"Examples - Wind.decode/4","doc":"iex> Wind.decode(conn, ref, websocket, message)\n    {:ok, conn, websocket, data}","ref":"Wind.html#decode/4-examples"},{"type":"function","title":"Wind.send/4","doc":"Statelessly send a websocket message.  This is a convenience function that\nwraps Mint.WebSocket the `encode/2` and `stream_request_body/3` functions.","ref":"Wind.html#send/4"},{"type":"function","title":"Examples - Wind.send/4","doc":"iex> Wind.send(conn, ref, websocket, message)\n    {:ok, conn, websocket}","ref":"Wind.html#send/4-examples"},{"type":"function","title":"Wind.setup/4","doc":"Statelessly setup a websocket connection.  This is a convenience function that\nwraps the Mint.WebSocket setup functions for a websocket.","ref":"Wind.html#setup/4"},{"type":"function","title":"Examples - Wind.setup/4","doc":"iex> Wind.setup(conn, ref, http_reply_message)\n    {:ok, conn, ref, websocket, response}","ref":"Wind.html#setup/4-examples"},{"type":"function","title":"Wind.setup_await/2","doc":"Synchronously setup a websocket connection.  See `setup/3`.","ref":"Wind.html#setup_await/2"},{"type":"function","title":"Examples - Wind.setup_await/2","doc":"iex> Wind.setup_await(conn, ref)\n    {:ok, conn, ref, websocket}","ref":"Wind.html#setup_await/2-examples"},{"type":"behaviour","title":"Wind.Client","doc":"`Client` is the basis for creating a connection module in your application.\n\n```elixir\n  defmodule Example do\n    use Wind.Client\n\n    def start_link() do\n      uri = URI.new!(\"http://example.com/ws\")\n      Wind.Client.start_link(__MODULE__, uri: uri)\n    end\n\n    def handle_connect(state) do\n      # Handle any post-connect setup here.\n      {:noreply, state}\n    end\n\n    def handle_frame({type, message}, state) do\n      IO.inspect({type, message}, label: \"frame\")\n      {:noreply, state}\n    end\n  end\n```","ref":"Wind.Client.html"},{"type":"callback","title":"Wind.Client.handle_connect/1","doc":"Invoked after a connection is established. Override to setup post-connection state.","ref":"Wind.Client.html#c:handle_connect/1"},{"type":"callback","title":"Wind.Client.handle_frame/2","doc":"Invoked for each received frame.","ref":"Wind.Client.html#c:handle_frame/2"},{"type":"function","title":"Wind.Client.send/2","doc":"","ref":"Wind.Client.html#send/2"},{"type":"function","title":"Wind.Client.start_link/3","doc":"","ref":"Wind.Client.html#start_link/3"},{"type":"type","title":"Wind.Client.frame/0","doc":"","ref":"Wind.Client.html#t:frame/0"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/), and this project adheres to\n[Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [Unreleased]\n\n## [0.3.0] - 2023-08-25\n\n- **BREAKING:** Return entire response from setup/3 and setup_await/2, this changes the return type.\n- Fixed issues for certain websocket servers that return extra data in the upgrade/setup phase (ws://echo.websocket.events/.ws)\n- Fixed defaults for non-TLS connections, was causing `:badarg` with `:gen_tcp`\n- Updated some dependencies\n\n## [0.2.4] - 2023-06-12\n\n- Rolled back fix from 0.2.3\n- Fixed some issues with websocket state\n\n## [0.2.3] - 2023-06-12\n\n- Fixed some issues with websocket state\n\n## [0.2.2] - 2023-05-12\n\n- Added some guards\n- Fixed some specs\n- Updated some docs\n\n## [0.2.1] - 2023-04-07\n\n- Handle errors a bit better by issuing :stop\n- Fixed docs, dialyzer errors, and some specs\n\n## [0.2.0] - 2023-03-19\n\n#","ref":"changelog.html"},{"type":"extras","title":"Breaking - Changelog","doc":"- Change Wind.Stream to Wind.Client to keep namespace for future functionality.\n\n## [0.1.0] - 2023-03-17\n\n- Initial implementation\n    - includes basic tools to build websocket clients, more to come...","ref":"changelog.html#breaking"}],"content_type":"text/markdown"}